summaryrefslogtreecommitdiff
path: root/home/xyz/.local/bin/curlkg
diff options
context:
space:
mode:
Diffstat (limited to 'home/xyz/.local/bin/curlkg')
-rwxr-xr-xhome/xyz/.local/bin/curlkg42
1 files changed, 42 insertions, 0 deletions
diff --git a/home/xyz/.local/bin/curlkg b/home/xyz/.local/bin/curlkg
new file mode 100755
index 00000000..9389e680
--- /dev/null
+++ b/home/xyz/.local/bin/curlkg
@@ -0,0 +1,42 @@
+#!/bin/sh
+
+# references:
+# https://blog.csdn.net/qq_41730930/article/details/79327757
+# https://blog.csdn.net/u011112876/article/details/89634505
+# https://github.com/pystardust/ytfzf
+
+homepage_url='https://node.kg.qq.com/cgi/fcgi-bin/kg_ugc_get_homepage'
+music_url='https://node.kg.qq.com/cgi/fcgi-bin/fcg_get_play_url'
+# num seems only 8 and 15 works
+num=15
+tmp_json_file="$(mktemp --suffix=.json)"
+
+while getopts u: opt; do
+ case $opt in
+ u) uid="$OPTARG";;
+ \?) exit 1;;
+ esac
+done
+# for lan lan, uid=649b9e82272a348b
+# for cheng ruan, uid=64949d822c25328c
+[ -z "$uid" ] && echo 'error: must provide share_uid
+ex: curlkg -u 649b9e82272a348b ./' >&2 && exit 1
+shift $((OPTIND-1))
+download_dir="${1:-"$PWD"}"
+[ -d "$download_dir" ] || mkdir -p "$download_dir"
+
+get_json ()
+{
+ curl -s -G --data-urlencode type=get_uinfo -d outCharset=utf-8 -d start="$1" -d num=$num -d share_uid="$uid" "$homepage_url" | sed 's/.*({\(.*\)}).*/{\1}/' >> "$tmp_json_file"
+}
+
+get_json 1
+ugc_total_count=$(jq '.data.ugc_total_count' "$tmp_json_file")
+# can also use while loop with i=$((i+1))
+# the calculation considers both ugc_total_count%num==0 and ugc_total_count%num>0
+for i in $(seq 2 $(((ugc_total_count+num-1)/num))); do
+ get_json "$i"
+done
+
+jq -r '.data.ugclist[]|"'"$music_url"'?shareid=\(.shareid)\n out=\(.title)_\(.time).m4a"' "$tmp_json_file" | aria2c -d "$download_dir" --auto-file-renaming=false --console-log-level=warn -i-
+rm "$tmp_json_file"